/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

var PageSelection = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsIVariant);
var PageURL = ""
var PageHost = "";
var ForcePrompt = false;
var PromptPref = "";
var ConfigLastWill = "";

function FillMenu(){
  FetchPrefs(EntryHash, "Entries.");
  var ppMenu = document.getElementById("cq-ppm");
	while (ppMenu.hasChildNodes()) {ppMenu.removeChild(ppMenu.lastChild)}
  var entries = EntryHash._Items();
  for (entry in entries){
	  if (entries[entry].Context){
		  var ppItem = document.createElement("menuitem");
		  ppItem.setAttribute("label", entries[entry].Title);
		  ppItem.setAttribute("onmouseover", "SelectedEnrtyId="+entries[entry].eId+";");
		  ppItem.setAttribute("oncommand", "ProcessEntry('"+entries[entry].eId+"')");
		  ppMenu.appendChild(ppItem);
		}
  }
}

function ProcessEntry(EntryId){
	getPageParams();
	entry = EntryHash._Item(EntryId);
	URLTempl = entry.URL;

	if (entry.Method == "POST"){
		PassData(URLTempl);
		goUrl("chrome://conquery/content/post.xul");
	}else{
		URLTempl = ProcessUserVars(URLTempl);
		goUrl(URLTempl);
	}
}

function PassData(urltempl){
// Ok! I gave up! If somebody knows the better way to pass data to new Tab, please e-mail me..
// Till then we will:
// - save data to mozprefs;
// - open new tab with .xul
// - read it from there & erase.

PageSelection = encodeURI(PageSelection);
  Prefs.deleteBranch("temp.");
  Prefs.setCharPref("temp.POSTURL", urltempl);
  Prefs.setCharPref("temp.PageSelection", PageSelection);
  Prefs.setCharPref("temp.PageURL", PageURL);
  Prefs.setCharPref("temp.PageHost", PageHost);
}

function goUrl(uri) {
	PageSelection = "";
	PageURL = ""
	PageHost = "";
  var browser = getBrowser();
	browser.selectedTab = browser.addTab(uri);
}

function OpenCfgDialog(){
	window.openDialog("chrome://conquery/content/conquery-pref.xul", "ConQuery config",	"modal,resizable=yes");
  if (ConfigLastWill){
    ProcessEntry(ConfigLastWill);
    ConfigLastWill = "";
  }
}

function ProcessUserVars(uservar){
	//Recognized vars:
	//[:selection]
	//[:url]
	//[:host]
	//[:prompt]
	//if there is no selection data, we will prompt user to input one

  var prmpt = "";
  if ((uservar.search(/\[:selection\]/i)!=-1) && (!PageSelection)) {
  	prmpt = prompt("No selected text found!\n Input text to pass to URL:", "");
    PageSelection = prmpt;
    }
  uservar = uservar.replace(/\[:selection\]/gi, PageSelection);
  uservar = uservar.replace(/\[:url\]/gi, PageURL);
  uservar = uservar.replace(/\[:host\]/gi, PageHost);
  if (uservar.search(/\[:prompt\]/gi)!=-1){
  	prmpt = prompt("Input text to pass to URL", "");
  	uservar = uservar.replace(/\[:prompt\]/gi, prmpt);
  }
 return uservar;
}

function getPageParams(){
	try{
		var focusedWindow = document.commandDispatcher.focusedWindow;
		PageSelection = String(focusedWindow.__proto__.getSelection.call(focusedWindow));
	}catch(er){PageSelection=""}
  
  try{
  	PageURL = focusedWindow.location.href;
	}catch(er){PageURL=""}
	
	try{
	  	PageHost = focusedWindow.location.host;
	}catch(er){PageHost=""}
}