/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

var PlugsPath = window.opener.top.PlugsDirBox.value;
var ReadOnlyCqr = window.opener.top.ReadOnlyCqr.checked;
var delim = window.opener.top.delim;
var AllFiles = [];

function loader(){
window.setTimeout('ExportMozexPlugins();', 0);
}
function setstatus(cnt){
var pStatus  = document.getElementById('parserstatus');	
	pStatus.value = cnt;
}

function ExportMozexPlugins(){
try{
  if (!PlugsPath) return;
  exploredir(PlugsPath);
  var cnt = 0;
  for (file in AllFiles){
		f = AllFiles[file];
		if (ReadOnlyCqr){
		  var ExtRE = new RegExp("(\.cqr)","i");
		}else{
		  var ExtRE = new RegExp("(\.(cqr)|(src))","i");
		}
		var fext = f.substr(f.length - 4, f.length);
		if (ExtRE.test(fext)){
			//window.setTimeout('setstatus("Parsed: '+cnt+' files so far")',7000);
			cnt++;
			filedata = cqReadFile(f);
			filedata = filedata.replace(/#.*/ig,"");
			filedata = filedata.replace(/[\n\r\f\t]/ig,"  ");
			SearchTagData = filedata.match(/<search.+?<\/search>)/gi);
			mcSearch = null;
			mcSearch = GetTagFromString("search", SearchTagData);
			if (mcSearch[0]){
				var act = "";
				var amp = "";
				var cqTitle = mcSearch[0].name;
				var cqMethod = mcSearch[0].method;
				var cqDesc = mcSearch[0].description;
				var inp = GetTagFromString("input", SearchTagData);
				for (each in inp){
					act += amp+inp[each].name+"="+inp[each].value;
					amp = "&";
				}
				var cqAction = mcSearch[0].action+"?"+act;
				
				if ((!cqTitle) || (cqTitle=="undefined")) {
				  cqTitle = "zzzz!!! PARSEERROR: "+f;
				  cqDesc = f + " has no <search> tag or <search> tag not well formed!";
				}
				if ((!cqMethod) || (cqMethod=="undefined")) cqMethod = "GET";
				if ((!cqDesc) || (cqDesc=="undefined")) cqDesc = "";
				if ((!cqAction) || (cqAction=="undefined")) cqAction = "!!!PARSEERROR!!!";
				
				window.opener.top.repEntryHash._Add(
			  	"",
			  	cqTitle,
			  	cqAction,
			  	cqMethod,
			  	cqDesc,
			  	"");
			}else{
				window.opener.top.repEntryHash._Add(
			  	"",
			  	"zzzz!!! PARSEERROR: "+f,
			  	"none",
			  	"GET",
			  	f + " has no <search> tag or <search> tag not well formed!",
			  	"");
			}
		}
  }
}catch(er){alert(er)}
initRepTree(window.opener.top.repEntryList, window.opener.top.repEntryHash)
window.close()
}

function initRepTree(list, srcHash){
//window.setTimeout('setstatus("Buidling tree...")',7000);
  var cnt = 0;
  while (list.hasChildNodes()) {list.removeChild(list.lastChild)}
  //while (list.hasChildNodes()) {alert(list.lastChild.name)}
  var ondk;
  var onsel;
  var item;
  var node;
  var celldata;
  var entries = srcHash._Items();
	var treecols = document.createElement('treecols');
	var treecol = document.createElement('treecol');
  treecol.setAttribute("label", "Found plugins");
  treecol.setAttribute("flex", "1");
  treecol.setAttribute("id", "www");
	treecols.appendChild(treecol);
	list.appendChild(treecols);
	var tch = document.createElement('treechildren');
	//list.appendChild(tch);

  for (i=0; i<entries.length; i++){
    //window.setTimeout('setstatus("Building tree: '+cnt+' childes so far")',7000);
  	//cnt++;
  	ondk='if (isValidLeftClick(event,"listitem")) CopyEntry(repEntryHash, '+entries[i].eId+', EntryHash, EntryList);';
  	//onsel = 'onSelectRep('+entries[i].eId+')';
  	onsel = 'alert('+entries[i].eId+');';
    item = document.createElement('treeitem');
    item.setAttribute('id', entries[i].eId);
    row = document.createElement('treerow');

    row.setAttribute('id', entries[i].eId);
    row.setAttribute('ondblclick', ondk);
    //row.setAttribute('allowevents', true);
		
    celldata = document.createElement('treecell');
    celldata.setAttribute('label', entries[i].Title);
    celldata.setAttribute('onselect', onsel);
    row.appendChild(celldata);
    
    //item.setAttribute('onselect', 'alert("here");');
    //if (isValidLeftClick(event,"listitem")) 
    item.appendChild(row);
    tch.appendChild(item);
    //list.insertBefore(item, prevItem);
  }
  list.appendChild(tch);
}

function GetTagFromString(tag, str){
	//This extracts all <tag param=value> patterns from str
	//WARNING! It sucks on patterns like <tag param="from > to"> extracting only <tag param="from >
	var lcTagsData = [];
	var lcTagsBuff = "  ";
	//var lcTagsRE = new RegExp("<"+tag+" .+?>","i");
	var lcTagsRE = new RegExp("<"+tag+" .[^<]+?>","i");
	while (lcTagsBuff){
	  lcTagsBuff = String(str).match(lcTagsRE);
	  if (lcTagsBuff){
			lcTagsData[lcTagsData.length]=ParseTagParams(lcTagsBuff);
	    str = String(str).replace(lcTagsBuff, "");
	  }
	}
return lcTagsData;
}

function ParseTagParams(tag){
  var lcParams = new Object;
	var lcParamsBuff = "  ";
  var lcParamsData = [];
  //To correct Mycroft's "user" in <input>.
  //To plugin coders:
  //   Guys, please, no <input name="blah" user=""> and unclosed <search> tags!
  //   Read Mycroft spec! Such inputs will have value="!!!PARSEERROR!!!"
  tag = String(tag).replace(/\s+?user(?=\s*[\/>])/i, " value="+String.fromCharCode(34)+"[:selection]"+String.fromCharCode(34));
	lcParams["value"]="!!!PARSEERROR!!!";
  while (lcParamsBuff){
	//This will understand only <"> but not <'> as pattern, sorry :(
		lcParamsBuff = String(tag).match(/\w+\s*?=\s*?".*?"/i);
		if (lcParamsBuff){
			lcParamsArr = String(lcParamsBuff).split(/=\s*"/);
			lcParamsArr[1] = lcParamsArr[1].replace(/^\s+/, "");
			lcParams[String(lcParamsArr[0].replace(/\s+/,"")).toLowerCase()] = lcParamsArr[1].replace(/"\s*/, "");
			//show(lcParams[String(lcParamsArr[0].replace(/\s+/,"")).toLowerCase()] +">>>>>"+ String(lcParamsArr[0].replace(/\s+/,"")).toLowerCase());
			tag = String(tag).replace(lcParamsBuff, "");
		}
	}
  //for not parenthesized params (i.e. param=value)
  lcParamsBuff = "  ";
  while (lcParamsBuff){
		lcParamsBuff = String(tag).match(/\w+?\s*?=\s*?\w+?(?=[\s\/>])/i);
		if (lcParamsBuff){
			lcParamsArr = String(lcParamsBuff).split(/=/);
			lcParamsArr[1] = lcParamsArr[1].replace(/^\s+/, "");
			lcParams[String(lcParamsArr[0].replace(/\s+/,"")).toLowerCase()] = lcParamsArr[1].replace(/\s+$/, "");
			tag = String(tag).replace(lcParamsBuff, "");
		}
	}
return lcParams;
}

function exploredir(start){
  var items = cqReadDir(start);
  items.QueryInterface(Components.interfaces.nsISimpleEnumerator);
  while (items.hasMoreElements()) {
    var i = items.getNext();
    i.QueryInterface(Components.interfaces.nsIFile);
    if (i.isDirectory()){
      exploredir(start+delim+i.leafName);
    }else{
      AllFiles[AllFiles.length] = start+delim+i.leafName;
    }
  }
}


function cqReadDir(dirname) {
    var dir = Components.classes["@mozilla.org/file/local;1"].
               createInstance(Components.interfaces.nsILocalFile);
    dir.initWithPath(dirname);
    if (dir.isDirectory()) {
        return dir.directoryEntries;
    }
    else {
        alert("Error!");
    }
}

function cqReadFile(filename) {
    var MODE_RDONLY = 0x01;
    var PERM_IRUSR = 00400;
    
    try {
        var file = Components.classes["@mozilla.org/file/local;1"].
                   createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(filename);
        if (file.exists() && file.isReadable()) {
            var is = Components.classes["@mozilla.org/network/file-input-stream;1"].
                     createInstance(Components.interfaces.nsIFileInputStream);
            is.init(file, MODE_RDONLY, PERM_IRUSR, 0);
            var sis = Components.classes["@mozilla.org/scriptableinputstream;1"].
                createInstance(Components.interfaces.nsIScriptableInputStream);
            sis.init(is);
            var data = sis.read(sis.available());
            sis.close();
            is.close();
            return data;
        }
        else {
            alert("File" + filename + "read error!");
            return null;
        }
    }
    catch (err) {
        alert("File" + filename + "read error:\n"+err);
    }
    return null;
}

